import xmlrpclib
from inc_connect import *
from tools import *
import string
import sys
import cgi
from urllib2 import urlopen,quote


def getGPS(GAPIKEY,url,ville,cp,pays):
    query=quote(ville+' '+cp+', '+pays)
    query=url+query+"&output=csv&key="+GAPIKEY
    try:
        fh = urlopen(query)
        ret=fh.read()
        l=ret.split(',')
    except Exception, e:
        return None

    ret=[float(l[2]),float(l[3])]
    return ret



s_url="http://maps.google.com/maps/geo?q="
GAPIKEY=raw_input("Entrez votre clef Google API : ")
pays=raw_input("Pays : (Ex:France,Reunion) ")


print " ==================================================="
print "Veuillez renseigner les deux points de references "
print " ==================================================="

print "1er point"
oGPS=None
while oGPS == None:
    ville=raw_input("Ville/ Adresse :")
    oGPS=getGPS(GAPIKEY,s_url,ville,'',pays)
    print "Coordonnees GPS de :"+ville+" ("+str(oGPS[0])+","+str(oGPS[1])+")"
    oGPS1=oGPS
oP=raw_input("Coordonnee X,Y associe (x,y):")
oPXY1=[int(coord) for coord in oP.split(',')]


print ""
print "2eme point"
oGPS=None
while oGPS == None:
    ville=raw_input("Ville/ Adresse :")
    oGPS=getGPS(GAPIKEY,s_url,ville,'',pays)
    print "Coordonnees GPS de :"+ville+" ("+str(oGPS[0])+","+str(oGPS[1])+")"
    oGPS2=oGPS
oP=raw_input("Coordonnee X,Y associe (x,y):")
oPXY2=[int(coord) for coord in oP.split(',')]

lat_width=abs(oGPS2[0]-oGPS1[0])
long_width=abs(oGPS2[1]-oGPS1[1])

iPXY_width=abs(oPXY2[0]-oPXY1[0])
iPXY_height=abs(oPXY2[1]-oPXY1[1])

print " Recuperation des coordonnees GPS "
f2=open('/home/sentinelle/local/client/_client/etabs.txt','w')

oProxy=xmlrpclib.ServerProxy(sUrlZephir)
etabs=convert(oProxy.etabs.get_etab()[1])
for etab in etabs:
    etab['ville']= etab['ville'].upper().replace("CEDEX","").strip()
    rne= etab['rne']
    ville=etab['ville']
    nom=etab['libelle']
    
    query=quote(etab['ville']+' '+etab['cp'][:2]+', '+pays)
    query=s_url+query+"&output=csv&key="+GAPIKEY
    try:
        fh = urlopen(query)
        ret=fh.read()
        l=ret.split(',')
        
    except Exception, e:
        print e
        l=[0,0,0,0]
    

    Lat=float(l[2])
    Lon=float(l[3])

    if Lat==0 and Lon==0:
        x=-1
        y=-1
    else:
        x=(int)(((Lon-oGPS1[1])*iPXY_width)/long_width + oPXY1[0])
        y=(int)(-((Lat-oGPS1[0])*iPXY_height)/lat_width + oPXY1[1])

    ligne=rne+","+nom+","+str(x)+","+str(y)+","+str(Lon)+","+str(Lat)+","+ville
    print ligne
    f2.write(ligne+"\n")


f2.close()
